/* 
 * site.h
 *
 * x-kernel v3.1	12/10/90
 *
 * Copyright (C) 1990  Larry L. Peterson and Norman C. Hutchinson
 */

/************************************************************************
/*
/* String giving the absolute pathname of the xkernel main directory
/*
/************************************************************************/

#define SITE_ROOT_DIRECTORY "/usr/xkernel"

/************************************************************************
/*
/*   Site dependent servers: where PROFILE runs, where DNS runs, and
/*   where IP router runs
/*
/************************************************************************/

#define SITE_DEVELOP_HOST {192, 12, 69, 21} 	      /* profile host    */
#define SITE_DNS_SRV_NAME "cheltenham.cs.arizona.edu" /* DNS host (name) */
#define SITE_DNS_SRV_ADDR "192.12.69.60"	      /* DNS host (addr) */
#define SITE_IP_GTW 	  { 192, 12, 69, 1 }          /* IP gateway      */





/************************************************************************
/*
/*   Name, IP address, and Ethernet address for the two processors
/*   (client and server) on which the x-kernel will typically be
/*   booted. These defaults can be overriden by the -s and -c options
/*   to the boot program.
/*
/************************************************************************/

#define SITE_SERVER_NAME "benguiat"		   /* server's name     */
#define SITE_SERVER_IP {192, 12, 69, 8}		   /* server's IP addr  */
#define SITE_SERVER_ETH {0x0800, 0x2001, 0x5040}   /* server's ETH addr */

#define SITE_CLIENT_NAME "lubalin"		   /* client's name     */
#define SITE_CLIENT_IP {192, 12, 69, 45}	   /* client's IP addr  */
#define SITE_CLIENT_ETH {0x0800, 0x2001, 0x51d6}   /* client's ETH addr */



/************************************************************************
/*
/*  Default User ID and Group ID for test programs which require a
/*  "harmless" UID/GID.  These should be set to values which are otherwise
/*  unused at the site. 
/************************************************************************/

#define SITE_DEFAULT_UID	32323
#define SITE_DEFAULT_GID	255	/* xkernel group */
