/*
 * xdr_prim.c
 *
 * x-kernel v3.1	12/10/90
 *
 * Copyright (C) 1990  Larry L. Peterson and Norman C. Hutchinson
 */

#include <rpc/rpc.h>
#include "xkernel.h"
int tracexdr=0;

decode_xdr(key,indata,inlen,outdata)
int (*key)();
char *indata;
int inlen;
char **outdata;
{
    XDR xdrs;
    int xdr_len;
    struct rpc_key *my_key;
   
    TRACE3(xdr,3,"entering rpc_decode inlen = %d indata = %d *outdata %d\n",inlen,indata,*outdata);
    IFTRACE(xdr,4) print_xdr(indata,inlen);

    my_key = (struct rpc_key *)key;
    xdrmem_create(&xdrs,indata,inlen,XDR_DECODE);
    if ((*key)(&xdrs,outdata)) {
	xdr_len = (int) XDR_GETPOS(&xdrs);
    	TRACE0(xdr,3,"exiting rpc_decode \n");
	return(xdr_len);
    }
    TRACE0(xdr,3,"error: rpc_decode xdr failed\n");
    return(-1);
}
  
encode_xdr(key,outdata,outlen,indata)
int (*key)();
char *outdata;
int outlen;
char **indata;
{
    XDR xdrs;
    struct rpc_key *my_key;
    int xdr_len;
    
    TRACE0(xdr,3,"entering rpc_encode\n");

    xdrmem_create(&xdrs,outdata,outlen,XDR_ENCODE);
    if ((*key)(&xdrs,indata)) {
	xdr_len = (int) XDR_GETPOS(&xdrs);
   	TRACE1(xdr,3,"exit rpc_encode xdr_len = %d \n",xdr_len);
	return(xdr_len);
    }
    TRACE0(xdr,3,"error: rpc_encode xdr failed\n");
    return(-1);
}
print_xdr(buf,len)
unsigned char *buf;
int len;
{
   int i;

   printf("raw xdr string = ");
   for (i =0;i<len;i++) {
	printf(" %x ",buf[i]);
   } 
   printf("\n");
}
