| 
| ms_process_s.S
|
| x-kernel v3.1	12/10/90
|
| Copyright (C) 1990  Larry L. Peterson and Norman C. Hutchinson
|

#include "ms_consts.h"
#undef	HANDLER
#include "ms_interrupt.h"

	.text

	.globl	_Ms_Switch
_Ms_Switch:
#ifndef NDEBUG
	tstl	_GotHit
	beq	1f
	trap	#14
1:
#endif
	movw	#0x0080, sp@-
	pea	1f
	movw	sr, sp@-
	orw	#0x0700, sr
	movl	_Active,sp@-
	jbsr	_Ms_Addready
	addqw	#4,sp
	jra	_Switch
1:
	rts

	.globl	_Switch
_Switch:
#ifndef NDEBUG
	addql	#1, _nSwitches
#endif
	movl	a0, sp@-
	movl	_Active, a0
	moveml	#0x7FFF, a0@(Process_ps_regs_r_d0)
	movl	sp@+, a0@(Process_ps_regs_r_a0)
	movl	sp, a0@(Process_ps_regs_r_a7)
	movl	usp,a1
	movl    a1, a0@(Process_ps_regs_r_usp)
#ifndef NDEBUG
  	cmpl	#3,_traceprocessswitch
  	blt	1f
  	pea	2f
	.data
2:	.asciz	"Suspending "
	.text
  	jbsr	_printf
  	addqw	#4, sp
  	pea	1
  	movl	_Active, sp@-
  	jbsr	_DisplayProcess
  	addqw	#8, sp
1:
	movw	sr, d0
	andw	#0x0700, d0
	cmpw	#0x0700, d0
	beq	1f
	.data
2:	.asciz	"_Switch with interrupts enabled"
	.text
	pea	2b
	jbsr	_Kabort
	addqw	#4, sp
1:
#endif
	.globl  _Ms_ActivateReadyqHead
	.globl	_Ms_Idle
_Ms_Idle:
_Ms_ActivateReadyqHead:
	movl	_StackBottom, sp
#ifdef DEBUGRQ
	moveml	#0xc0c0, sp@-
	pea	0
	jbsr	_Ms_CheckOutRQ
	addqw	#4, sp
	moveml	sp@+, #0x0303
#endif
	bfffo	_readyBits{#0:#0},d7
	beq	5f
	lea	_readyQueues,a0
	lea	a0@(0,d7:l:4),a4
	movl	a4@,a3
	movl	a3@,a5
	cmpl	a3,a5
	jne	L112
	bfclr	_readyBits{d7:#1}
	clrl	a4@
	jra	L113
5:	
	clrl	_Active
	stop	#0x2000
	orw	#0x0700, sr
	jra	_Ms_ActivateReadyqHead
L112:
	movl	a5@,a3@
L113:
#ifdef DEBUGRQ
	moveml	#0xc0c0, sp@-
	pea	0
	jbsr	_Ms_CheckOutRQ
	addqw	#4, sp
	moveml	sp@+, #0x0303
#endif
	movl	a5,_Active
	clrl	a5@
	clrl	a5@(Process_queuePtr)
#ifndef NDEBUG
	tstl	_traceprocessswitch
	beq	1f
	tstl	a5@(Process_pid)
	jeq	1f
	moveq	#0,d0
	cmpl	#0x1,_traceprocessswitch
	sgt	d0
	negb	d0
	movl	d0,sp@-
	pea	a5@
	jbsr	_DisplayProcess
	addqw	#0x8,sp
1:
#endif
	movl	a5@(Process_aspace),d0
	cmpl	_AddressableAspace,d0
	jeq	1f
	movl	d0,sp@-
	jbsr	_Ms_SetAddressableAspace
	addqw	#0x4,sp
1:
#ifdef DEBUGRQ
	movl	a5@(Process_ps_regs_r_a7), sp@-
	pea	a5@
	jbsr	_CheckOutStack
	addqw	#8, sp
#endif
	movl    a5@(Process_ps_regs_r_usp), a0
	movl	a0, usp
	moveml  a5@(Process_ps_regs_r_d0), #0xFFFF
	.globl	_scheduleProcessRTE
_scheduleProcessRTE:
	rte

	.globl	_Ms_P
_Ms_P:
#ifndef NDEBUG
	tstl	_GotHit
	beq	1f
	trap	#14
1:
#endif
	movl	sp@(4), a0		| a0 == semaphore
	movw	sr, d0
	orw	#0x0700, sr
#ifdef DEBUGRQ
	moveml	#0xc0c0, sp@-
	pea	0
	jbsr	_Ms_CheckOutRQ
	addqw	#4, sp
	moveml	sp@+, #0x0303
#endif
	tstw	a0@(Semaphore_count)
	bge	9f
	movw	#0x0080, sp@-
	pea	1f
	movw	d0, sp@-
	movl	_Active, d1
	movl	a0@(0x4),a1
	movl	d1,a1@
	movl	d1, a1
	clrl	a1@
#ifndef NDEBUG
	movb	#PS_WAITING, a1@(Process_state)
#endif
	movl	a0,a1@(Process_queuePtr)
	movl	a1,a0@(0x4)
#ifdef DEBUGRQ
	moveml	#0xc0c0, sp@-
	pea	a1@
	jbsr	_Ms_CheckOutRQ
	addqw	#4, sp
	moveml	sp@+, #0x0303
#endif
	jra	_Switch
9:
	movw	d0, sr
1:
	rts

	.globl	_Ms_Addready
_Ms_Addready:
	movl	sp@(4), a0		| pd
#ifndef NDEBUG
	link	a6, #0
#endif
	movw	sr, d1
	orw	#0x700, sr
	movl	a2, sp@-
	movw	#1, _DoSwitch
	moveq	#0, d0
	movw	a0@(Process_priority), d0	| prio in d0
#ifndef NDEBUG
	movb	#PS_READY, a0@(Process_state)
#endif
#ifdef DEBUGRQ
	moveml	#0xc0c0, sp@-
	pea	a0@
	jbsr	_Ms_CheckOutRQ
	addqw	#4, sp
	moveml	sp@+, #0x0303
	tstl	a0@(Process_queuePtr)
	beq	1f
	.data	
2:	.asciz	"Process already in RQ\012"
	.text
	pea	2b
	jbsr	_Kabort
	addqw	#4, sp
1:
	movl	#0x1, a0@(Process_queuePtr)
#endif
	lea	_readyQueues, a1
	lea	a1@(0,d0:l:4),a1	| headp in a1
	movl	a1@, a2			| head  in a2
	tstl	a2
	jeq	3f
	movl	a2@, a0@
	movl	a0, a2@
	jra	5f
3:
	movl	a0, a0@
	bfset	_readyBits{d0:#1}
5:
	movl	a0, a1@
	movl	sp@+, a2
#ifdef DEBUGRQ
	moveml	#0xc0c0, sp@-
	pea	0
	jbsr	_Ms_CheckOutRQ
	addqw	#4, sp
	moveml	sp@+, #0x0303
#endif
	movw	d1, sr
#ifndef NDEBUG
	unlk	a6
#endif
	rts

	.globl	_Block
_Block:
	jmp	_Switch
	rts


	.globl	_saveProcessState
_saveProcessState:
	movl	a0, sp@-
	movl	_Active, a0
	moveml	#0x7FFF, a0@(Process_ps_regs_r_d0)
	movl	sp@+, a0@(Process_ps_regs_r_a0)
	movl	sp, a0@(Process_ps_regs_r_a7)
	movl	usp,a1
	movl    a1, a0@(Process_ps_regs_r_usp)
	movw	#0x0080, sp@-
	pea	1f
	movw	sr, sp@-
	movl	sp, a0@(Process_ps_regs_r_a7)
	movl	sp@(8+4), a1
	movl	sp@(8+8), d0
	movl	d0, sp@-
	jsr	a1@
	addw	#12, sp
	clrl	d0
1:
	rts

	.globl	_Ms_Delay
_Ms_Delay:
	movl	sp@(4), d0
#ifndef NDEBUG
	movl	_Active, a0
	movb	#PS_WAITING, a0@(Process_state)
#endif

	movw	#0x0080, sp@-
	pea	1f
	movw	sr, sp@-
	orw	#0x0700,sr
	pea	1			| EV_ONCE
	movl	d0, sp@-
	movl	_Active, sp@-
	pea	_Ms_Addready
	jbsr	_event_register
	lea	sp@(0x10), sp
	jra	_Switch
1:
	rts

	.globl	_Ms_Splx
_Ms_Splx:
	movw	sp@(6),sr
	rts
